%define commit0                ee17851b42f21bb92c4b7581e80c0319e5384e6b

%define libname_major          1
%define libname_core_major     1
### Qt4 libraries
%define libname                %mklibname %name %libname_major
%define libname_core           %mklibname qtsinglecoreapplication %libname_core_major
%define libname_devel          %mklibname %name -d
%define libname_core_devel     %mklibname qtsinglecoreapplication -d
### Qt5 libraries
%define libname_qt5            %mklibname %name-qt5_ %libname_major
%define libname_core_qt5       %mklibname qtsinglecoreapplication-qt5_ %libname_core_major
%define libname_devel_qt5      %mklibname %name-qt5 -d
%define libname_core_devel_qt5 %mklibname qtsinglecoreapplication-qt5 -d

Summary:        Qt library to start applications only once per user
Name:           qtsingleapplication
Version:        2.6.1
Release:        %mkrel 22
Group:          Development/KDE and Qt
License:        GPLv3 or LGPLv2 with exceptions
URL:            https://docs.huihoo.com/qt/solutions/4/qtsingleapplication/qtsingleapplication.html
Source0:        https://github.com/qtproject/qt-solutions/archive/%{commit0}.tar.gz#/%{name}-%{commit0}.tar.gz
# Proposed upstream in https://codereview.qt-project.org/#/c/92417/
Source1:        qtsingleapplication.prf
# Proposed upstream in https://codereview.qt-project.org/#/c/92416/
Source2:        qtsinglecoreapplication.prf
# Proposed upstream in https://codereview.qt-project.org/#/c/92411/
Source3:        LGPL_EXCEPTION
# Proposed upstream in https://codereview.qt-project.org/#/c/92416/
Patch0:         qtsingleapplication-2.6.1-fda-build-qtsinglecoreapplication.patch
# Proposed upstream in https://codereview.qt-project.org/#/c/92415/
Patch1:         qtsingleapplication-2.6.1-fda-remove-included-qtlockedfile.patch
# Features for unbundling in Qupzilla, https://github.com/QupZilla/qupzilla/issues/1503
Patch2:         qtsingleapplication-2.6.1-fda-qupzilla.patch

### Qt4 Buildrequirement
BuildRequires:  pkgconfig(QtCore)
BuildRequires:  qt4lockedfile-devel

### Qt5 Buildrequirement
BuildRequires:  qtbase5-common-devel
BuildRequires:  qt5lockedfile-devel
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5Network)
BuildRequires:  pkgconfig(Qt5Widgets)

%description
For some applications it is useful or even critical that they are started
only once by any user. Future attempts to start the application should
activate any already running instance, and possibly perform requested
actions, e.g. loading a file, in that instance.

The QtSingleApplication class provides an interface to detect a running
instance, and to send command strings to that instance.

# ----------------------------

%package -n     %libname
Summary:        Qt library to start applications only once per user
Group:          Development/KDE and Qt
Requires:       qt4-common

%description -n %libname
For some applications it is useful or even critical that they are started
only once by any user. Future attempts to start the application should
activate any already running instance, and possibly perform requested
actions, e.g. loading a file, in that instance.

The QtSingleApplication class provides an interface to detect a running
instance, and to send command strings to that instance.

This is the library package for QtSingleApplication.

%files -n %libname
%doc README.TXT licenses/LGPL_EXCEPTION
# Caution! Unversioned .so file goes into -devel
%{_qt4_libdir}/lib*QtSolutions_SingleApplication*.so.%{libname_major}{,.*}

# ----------------------------

%package -n     %libname_devel
Summary:        Development files for %{name}
Group:          Development/KDE and Qt
Requires:       %{libname} = %{version}-%{release}
Provides:       qtsingleapplication-devel = %{version}-%{release}

%description -n %libname_devel
This package contains libraries and header files for developing applications
that use QtSingleApplication.

%files -n %libname_devel
%doc doc/html/ examples/
%{_qt4_libdir}/libQtSolutions_SingleApplication*.so
%dir %{_qt4_includedir}/QtSolutions/
%{_qt4_includedir}/QtSolutions/QtSingleApplication
%{_qt4_includedir}/QtSolutions/%{name}.h
%{_qt4_datadir}/mkspecs/features/qtsingleapplication.prf

# ----------------------------

%package -n     %libname_core
Summary:        Qt library to start applications only once per user
Group:          Development/KDE and Qt

%description -n %libname_core
For some applications it is useful or even critical that they are started
only once by any user. Future attempts to start the application should
activate any already running instance, and possibly perform requested
actions, e.g. loading a file, in that instance.

For console (non-GUI) applications, the QtSingleCoreApplication variant
is provided, which avoids dependency on QtGui.

This is the library package for QtSingleCoreApplication.

%files -n %libname_core
# Caution! Unversioned .so file goes into -devel
%{_qt4_libdir}/lib*QtSolutions_SingleCoreApplication*.so.%{libname_core_major}{,.*}

# ----------------------------

%package -n     %libname_core_devel
Summary:        Development files for qtsinglecoreapplication
Group:          Development/KDE and Qt
Requires:       %libname_core = %{version}-%{release}
Provides:       qtsinglecoreapplication-devel = %{version}-%{release}

%description -n %libname_core_devel
This package contains libraries and header files for developing applications
that use QtSingleCoreApplication.

%files -n %libname_core_devel
%{_qt4_libdir}/lib*QtSolutions_SingleCoreApplication*.so
%dir %{_qt4_includedir}/QtSolutions/
%{_qt4_includedir}/QtSolutions/QtSingleCoreApplication
%{_qt4_includedir}/QtSolutions/qtsinglecoreapplication.h
%{_qt4_datadir}/mkspecs/features/qtsinglecoreapplication.prf

# ----------------------------
### Qt5 ###

%package -n     %libname_qt5
Summary:        Qt5 library to start applications only once per user
Group:          Development/KDE and Qt
Requires:       qtbase5-common

Obsoletes:      %{_lib}qtsingleapplication1-qt5 < 2.6.1-13
Obsoletes:      %{_lib}qtsingleapplication-qt51 < 2.6.1-14

%description -n %libname_qt5
For some applications it is useful or even critical that they are started
only once by any user. Future attempts to start the application should
activate any already running instance, and possibly perform requested
actions, e.g. loading a file, in that instance.

The QtSingleApplication class provides an interface to detect a running
instance, and to send command strings to that instance.

This is the library package for QtSingleApplication.

This is a special build against Qt5.

%files -n %libname_qt5
%doc README.TXT licenses/LGPL_EXCEPTION
# Caution! Unversioned .so file goes into -devel
%{_qt5_libdir}/lib*Qt5Solutions_SingleApplication*.so.%{libname_major}{,.*}

# ----------------------------

%package -n     %libname_devel_qt5
Summary:        Development files for %{name}-qt5
Group:          Development/KDE and Qt
Requires:       %{libname_qt5} = %{version}-%{release}
Provides:       qtsingleapplication-qt5-devel = %{version}-%{release}

Obsoletes:      %{_lib}qtsingleapplication1-qt5-devel < 2.6.1-13

%description -n %libname_devel_qt5
This package contains libraries and header files for developing applications
that use QtSingleApplication with Qt5.

%files -n %libname_devel_qt5
%doc doc/html/ examples/
%{_qt5_libdir}/lib*Qt5Solutions_SingleApplication*.so
%dir %{_qt5_includedir}/QtSolutions/
%{_qt5_includedir}/QtSolutions/QtSingleApplication
%{_qt5_includedir}/QtSolutions/%{name}.h
%{_qt5_libdir}/qt5/mkspecs/features/qtsingleapplication.prf

# ----------------------------

%package -n     %libname_core_qt5
Summary:        Qt5 library to start applications only once per user
Group:          Development/KDE and Qt

Obsoletes:      %{_lib}qtsinglecoreapplication1-qt5 < 2.6.1-13
Obsoletes:      %{_lib}qtsinglecoreapplication-qt51 < 2.6.1-14

%description -n %libname_core_qt5
For some applications it is useful or even critical that they are started
only once by any user. Future attempts to start the application should
activate any already running instance, and possibly perform requested
actions, e.g. loading a file, in that instance.

For console (non-GUI) applications, the QtSingleCoreApplication variant
is provided, which avoids dependency on QtGui.

This is a special build against Qt5.

%files -n %libname_core_qt5
# Caution! Unversioned .so file goes into -devel
%{_qt5_libdir}/lib*Qt5Solutions_SingleCoreApplication*.so.%{libname_core_major}{,.*}

# ----------------------------

%package -n     %libname_core_devel_qt5
Summary:        Development files for qtsinglecoreapplication-qt5
Group:          Development/KDE and Qt
Requires:       %libname_core_qt5 = %{version}-%{release}
Provides:       qtsinglecoreapplication-qt5-devel = %{version}-%{release}

Obsoletes:      %{_lib}qtsinglecoreapplication1-qt5-devel < 2.6.1-13

%description -n %libname_core_devel_qt5
This package contains libraries and header files for developing applications
that use QtSingleCoreApplication with Qt5.

%files -n %libname_core_devel_qt5
%{_qt5_libdir}/lib*Qt5Solutions_SingleCoreApplication*.so
%dir %{_qt5_includedir}/QtSolutions/
%{_qt5_includedir}/QtSolutions/QtSingleCoreApplication
%{_qt5_includedir}/QtSolutions/qtsinglecoreapplication.h
%{_qt5_libdir}/qt5/mkspecs/features/qtsinglecoreapplication.prf

### End Qt5 ###
# ----------------------------

%prep
%setup -qnqt-solutions-%{commit0}/%{name}
%patch0 -p0
%patch1 -p0
%patch2 -p1

# use versioned soname
sed -i "s,head,%(echo '%{version}' |sed -r 's,(.*)\..*,\1,'),g" common.pri

mkdir licenses
cp -p %{SOURCE3} licenses

# We already disabled bundling this external library.
# But just to make sure:
rm -rf ../qtlockedfile/
sed -i 's,qtlockedfile\.h,QtSolutions/\0,' src/qtlocalpeer.h
rm src/{QtLocked,qtlocked}*

mkdir qt5
cp -p %{SOURCE1} %{SOURCE2} qt5
sed -i -r 's,-lQt,\05,' qt5/qtsingleapplication.prf
sed -i -r 's,-lQt,\05,' qt5/qtsinglecoreapplication.prf

# additional header needed for Qt5.5
sed -i -r 's,.include,\0 <QtCore/QDataStream>\n\0,' src/qtlocalpeer.h


%build
# Does not use GNU configure
./configure -library
### Qt4 build ###
%{qmake_qt4}
%make_build

### Qt5 build ###
pushd qt5
%{qmake_qt5} ..
%make_build

%install
# libraries
mkdir -p %{buildroot}%{_libdir}
cp -a lib/* %{buildroot}%{_libdir}
chmod 755 %{buildroot}%{_libdir}/*.so*

# headers
mkdir -p %{buildroot}%{_qt4_includedir}/QtSolutions
cp -ap \
    src/qtsingleapplication.h \
    src/QtSingleApplication \
    src/qtsinglecoreapplication.h \
    src/QtSingleCoreApplication \
    %{buildroot}%{_qt4_includedir}/QtSolutions

mkdir -p %{buildroot}%{_qt5_includedir}
# symlink is not possible due to split into individual subpackages
cp -ap %{buildroot}%{_qt4_includedir}/QtSolutions %{buildroot}%{_qt5_includedir}

mkdir -p %{buildroot}%{_qt4_datadir}/mkspecs/features %{buildroot}%{_qt5_libdir}/qt5/mkspecs/features
install -p -m644 %{SOURCE1} %{SOURCE2} %{buildroot}%{_qt4_datadir}/mkspecs/features
install -p -m644 qt5/*.prf %{buildroot}%{_qt5_libdir}/qt5/mkspecs/features


%changelog
* Thu Dec 17 2020 umeabot <umeabot> 2.6.1-22.mga8
+ Revision: 1659640
- Rebuild for new Qt5

* Sat Feb 15 2020 umeabot <umeabot> 2.6.1-21.mga8
+ Revision: 1527907
- Mageia 8 Mass Rebuild
+ daviddavid <daviddavid>
- update URL

* Fri Jul 26 2019 daviddavid <daviddavid> 2.6.1-20.mga8
+ Revision: 1424451
- rebuild for new Qt5 headers path

* Mon Apr 01 2019 umeabot <umeabot> 2.6.1-19.mga7
+ Revision: 1384527
- Qt5 Rebuild

* Sun Sep 23 2018 umeabot <umeabot> 2.6.1-18.mga7
+ Revision: 1300727
- Mageia 7 Mass Rebuild

* Thu Apr 19 2018 kekepower <kekepower> 2.6.1-17.mga7
+ Revision: 1220082
- Update to git commit ee17851b42f21bb92c4b7581e80c0319e5384e6b, 2017-10-23

* Sun Apr 24 2016 daviddavid <daviddavid> 2.6.1-16.mga6
+ Revision: 1005847
- add patch from fedora to add features for Qupzilla
  * https://github.com/QupZilla/qupzilla/issues/1503

* Fri Jan 08 2016 daviddavid <daviddavid> 2.6.1-15.mga6
+ Revision: 920630
- do not install Qt5 libraries into libqtsingleapplication1 Qt4 subpackage

* Thu Jan 07 2016 daviddavid <daviddavid> 2.6.1-14.mga6
+ Revision: 920372
- rename libqtsingleapplication-qt51 to libqtsingleapplication-qt5_1
- rename libqtsinglecoreapplication-qt51 to libqtsinglecoreapplication-qt5_1

* Thu Jan 07 2016 daviddavid <daviddavid> 2.6.1-13.mga6
+ Revision: 920307
- fix Requires, Provides and BuildRequires list
- update some descriptions
- use a better libification for Qt5 subpackages

* Thu Jan 07 2016 dglent <dglent> 2.6.1-12.mga6
+ Revision: 920165
+ rebuild (emptylog)

* Wed Jan 06 2016 dglent <dglent> 2.6.1-11.mga6
+ Revision: 920160
- Add qt5 support mga#16523

* Mon Dec 28 2015 pterjan <pterjan> 2.6.1-10.mga6
+ Revision: 916618
- Fix buildRequires

* Wed Oct 15 2014 umeabot <umeabot> 2.6.1-9.mga5
+ Revision: 746341
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.6.1-8.mga5
+ Revision: 688559
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 2.6.1-7.mga4
+ Revision: 521228
- Mageia 4 Mass Rebuild

* Sat Jan 19 2013 fwang <fwang> 2.6.1-6.mga3
+ Revision: 389701
- add fedora patch to fix build
+ umeabot <umeabot>
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Jan 25 2012 mikala <mikala> 2.6.1-5.mga2
+ Revision: 200683
- Rebuild for Qt4.8

* Tue Jan 17 2012 mikala <mikala> 2.6.1-4.mga2
+ Revision: 197455
- Add %%version-%%release in virtual provides (Florian Hubold)

* Tue Jan 17 2012 mikala <mikala> 2.6.1-3.mga2
+ Revision: 197376
- Switch to new qt4 macros & ensure that devel files are correctly located ( spotted by Florian Hubold)
+ dmorgan <dmorgan>
- Use new qt4 macros
- Rebuild against new qt4 and new include path

* Mon Jun 20 2011 ahmad <ahmad> 2.6.1-1.mga2
+ Revision: 110224
- Adapt the spec to the Mageia packaging policies
- imported package qtsingleapplication


* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.6.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Aug 11 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> 2.6.1-4
- Make the additional API patch backwards compatible

* Wed Jul 21 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> 2.6.1-3
- Split the qtsinglecoreapplication bits into their own subpackages

* Fri Jul 16 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> 2.6.1-2
- Add additional API to support clementine.

* Sun Jun 04 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> 2.6.1-1
- Change version to 2.6.1. Upstream uses weird version convention 2.6_1
- Own the directory %%{_qt4_headerdir}/QtSolutions/

* Sat May 01 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> 2.6-3
- Add comments to the extra source and patches
- Add a chmod 755 to make sure that the library gets the right permission

* Thu Apr 15 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> 2.6-2
- Include .prf file
- Don't bundle external qtlockedfile library
- Fix typo in the description

* Sun Apr 11 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> 2.6-1
- Initial Fedora package. Specfile partly borrowed from opensuse

* Thu Dec  3 2009 Todor Prokopov <koprok@nand.bg>
- Initial package.
